<?php
/*********************************************************************************************/
//																							 //
//                              InstantCMS v1.1   (c) 2008 FREEWARE                          //
//	 					  http://www.instantcms.ru/, info@instantcms.ru                      //
//                                                                                           //
// 						    written by Vladimir E. Obukhov, 2007-2008                        //
//                                                                                           //
/*********************************************************************************************/

function mod_tags($module_id){

	$inCore = cmsCore::getInstance();
	$inDB = cmsDatabase::getInstance();
	$cfg = $inCore->loadModuleConfig($module_id);
	if ($cfg['menuid']>0) {
		$menuid = $cfg['menuid'];
	} else {
		$menuid = $inCore->menuId();
	}

	$targeting = sizeof($cfg['targets']);

	if(!isset($cfg['minfreq'])) { $cfg['minfreq']=0; }
	if(!isset($cfg['minlen'])) { $cfg['minlen'] = 3; }
	if(!isset($cfg['maxtags'])) { $cfg['maxtags'] = 20; }
	if(!isset($cfg['swf_height'])) { $cfg['swf_height'] = 200; }
	if(!isset($cfg['swf_width'])) { $cfg['swf_width'] = 200; }
	if(!isset($cfg['swf_bg_color'])) { $cfg['swf_bg_color'] = "e0eaeF"; }
	if(!isset($cfg['view_num_swf'])) { $cfg['view_num_swf'] = 0; }
	if(!isset($cfg['view_num_txt'])) { $cfg['view_num_txt'] = 0; }

	if ($targeting){
		$sql = "SELECT t.*, COUNT(t.tag) as num
				FROM cms_tags t
				WHERE length( t.tag ) >= ".$cfg['minlen']." AND ";

		$t=1;
		foreach($cfg['targets'] as $key=>$value){
			if ($t === 1) { $sql .= " ("; }
			if ($value=='blog')
			{
				$sql .= 't.target="blogpost"';
			}
			else
			{
				$sql .= 't.target="'.$value.'"';
			}

			if ($t <= sizeof($cfg['targets'])-1) { $sql .= " OR "; } else { $sql .= ")"; }
			$t++;
		}

		$sql .= "\n" . "GROUP BY t.tag";
		$sql .= "\n"." ORDER BY num DESC Limit ".$cfg['maxtags'];

		$result = mysql_query($sql) or die(mysql_error());

		if (mysql_num_rows($result)){
			$tag2 = array();
			while($tag = mysql_fetch_assoc($result)){
				$tag2[$tag['tag']] = $tag;
			}
			if ($cfg['sortby'] == 'tag') { ksort($tag2); }

			//$maxsize = 55;
			//$minsize = 10;

			$size = array();
			for ($s=0; $s<10; $s++) { $size[] = 10 + ($s*4); }

			$tags = array();
			$summary = 0;
			foreach($tag2 as $k => $tag) {
				$next = sizeof($tags);
				$tags[$next]['title'] = $tag['tag'];
				$tags[$next]['num'] = $tag['num'];
				$summary += $tag['num'];
			}

#			echo '<div>';

			#     
			if ( cmsUserId() == 0 ){
				#  cmsUserId() == 0      ,     -
				#  cmsUserId() >= 0       
				#  cmsUserId() > 0      ,     -
				#  cmsUserId() == 1      ,      -
				#  cmsUserId() <> 1        ,     -
				# ,           id=54,  :
				#  if ( cmsUserId() == 0 ){
				#      :
				#  if ( ( cmsUserId() <> 1 ) and ( cmsUserId() <> 54 ) ){

				foreach($tags as $key=>$value){

					$tag = $tags[$key]['title'];
					$num = $tags[$key]['num'];
					$phrase = $tag;

					$phrase = urlencode($phrase);
					if ($num>$cfg['minfreq']){
						$prc = ceil(($num / $summary) * 100);

						for ($s=0; $s<10; $s++){
							if ($prc >= ($s*10)) { $fontsize = $size[$s]; }
						}
						if ( $cfg['view_num_txt'] == 1 ) {
							echo '<a class="tag" href="/search/tag/'.urlencode($phrase).'" style="padding:2px; font-size: '.$fontsize.'px">'.ucfirst($tag)." ($num)".'</a>'."\n";
						}else{
							echo '<a class="tag" href="/search/tag/'.urlencode($phrase).'" style="padding:2px; font-size: '.$fontsize.'px">'.ucfirst($tag).'</a>'."\n";							}
					}
				}
				echo '</div>';
			} else {
				echo '<div id="tags">      <a href="http://www.adobe.com/products/flashplayer/">FlashPlayer</a>.
				<script type="text/javascript">
				var rnumber = Math.floor(Math.random()*9999999);
				var widget_so = new SWFObject("/modules/mod_tags/tagcloud.swf?r="+rnumber, "tagcloudflash", "'.$cfg['swf_width'].'", "'.$cfg['swf_height'].'", "3", "#'.$cfg['swf_bg_color'].'");
				widget_so.addParam("allowScriptAccess", "always");widget_so.addVariable("tcolor", "0x333333");
				widget_so.addVariable("tspeed", "115");
				widget_so.addVariable("distr", "true");
				widget_so.addVariable("mode", "tags");
				widget_so.addVariable("tagcloud", "<tags>';
				foreach($tags as $key=>$value){
					$tag = $tags[$key]['title'];
					$num = $tags[$key]['num'];

					if ($num>$cfg['minfreq']){
						$prc = ceil(($num / $summary) * 100);
						for ($s=0; $s<10; $s++){
							if ($prc >= ($s*10)) { $fontsize = $size[$s]; }
						}
						if (( cmsUserId() == 1 ) and ( $cfg['view_num_swf'] == 1 )) {
							echo urlencode('<a class="tag" href="/search/tag/'.urlencode($tag)).urlencode('" style="font-size: '.$fontsize.'px">').ucfirst($tag)." ($num)".urlencode('</a>');
						}else{
							echo urlencode('<a class="tag" href="/search/tag/'.urlencode($tag)).urlencode('" style="font-size: '.$fontsize.'px">').ucfirst($tag).urlencode('</a>');
						}

					}
				}
				echo '</tags>");
				widget_so.write("tags");</script></div>';
			}
		} else { echo '<p>   </p>'; }
	} else {
		echo '<p>     .</p>';
	}
	return true;
}
?>